
/*                              ColorsRT                                  */

/*                         Autor:  Piotr Godek                            */

/* Program zastpuje inny,o nazwie Colors,znajdujcy si w katalogu Tools */

MODULE 'intuition/intuition','intuition/screens','intuition/intuitionbase',
       'reqtools','libraries/reqtools','gadtools','libraries/gadtools'

ENUM ER_NONE,ER_KICK,ER_REQ,ER_GAD,ER_VIS

DEF scr:PTR TO screen,ibase:PTR TO intuitionbase,vis,lock

PROC main() HANDLE
 VOID '$VER: Colors 2.0 (17.03.95) by Peter Godek'
 IF KickVersion(37)=0 THEN Raise(ER_KICK)
 IF (reqtoolsbase:=OpenLibrary('reqtools.library',38))=0 THEN Raise(ER_REQ)
 IF (gadtoolsbase:=OpenLibrary('gadtools.library',37))=0 THEN Raise(ER_GAD)
 lock:=LockIBase(0)
 ibase:=intuitionbase
 scr:=ibase.firstscreen
 UnlockIBase(lock)
 IF (vis:=GetVisualInfoA(scr,0))=0 THEN Raise(ER_VIS)
 RtPaletteRequestA('Select colors',0,[RTPA_COLOR,0,RT_SCREEN,scr,0])
 Raise(ER_NONE)
EXCEPT
 IF vis THEN FreeVisualInfo(vis)
 IF reqtoolsbase THEN CloseLibrary(reqtoolsbase)
 IF gadtoolsbase THEN CloseLibrary(gadtoolsbase)
 SELECT exception
        CASE ER_KICK
             WriteF('Required Kickstart V37 or higher !!!\n')
        CASE ER_REQ
             WriteF('Couldn''t open reqtools.library v38+ !!!\n')
        CASE ER_REQ
             WriteF('Couldn''t open gadtools.library v37+ !!!\n')
        CASE ER_REQ
             WriteF('Couldn''t lock visual info !!!\n')
 ENDSELECT
ENDPROC
